# Farm Fighter

Welcome to **Farm Fighter**, a fun 2d multiplayer game where you can run around, explore the world, and start your farming empire! But don't forget to defend your crops from the locals!

## Table of Contents

- [About the Game](#about-the-game)
- [Features](#features)
- [Installation](#installation)
- [Running the Game](#running-the-game)
- [Controls](#controls)
- [Game Mechanics](#game-mechanics)
- [Cloning and Building](#cloning-and-building)
- [Contributing](#contributing)
- [License](#license)

## About the Game

**Farm Fighter** is a multiplayer game set on the planet, Lutum. In this (mostly) open world, you can run around, loot structures, gather seeds, and choose an area to build your base! Make sure you explore, as only certain resources can be found in certain bioms in the world.

## Features

- **Multiplayer Gameplay:** Just a server you play the game on.
- **Weapons:** What if we had guns... that shoot spuds!
- **Farm Raids:** Make sure you defend your crops, because at night the locals will come and attack your farm!

## Installation

To get started with **Farm Fighter**, follow these steps:

1. **Clone the Repository** (see [Cloning and Building](#cloning-and-building) section below).
2. **Build the Project:** Use CMake to generate build files for your platform.
3. **Run the Game:** Execute the compiled game binary to start playing.

### Prerequisites

- **CMake:** Ensure that CMake is installed on your system.
- **Compiler:** A C++ compiler that supports C++23 or later.
- **Libraries:** The game may require additional libraries, which will be listed in the `CMakeLists.txt` file (these libraries should be auto installed by cmake).

## Running the Game

Once you have built the project, you can run the game by executing the generated binary, usually in `./client/` (and `./server/` for the server binary)

## Controls

- **Movement:** WASD or Arrow Keys
- **Attack:** Left Mouse Button or Spacebar
- **Inventory:** I
- **Pause Menu:** Escape

## Game Mechanics

- **Health and Damage:** Each character has a health bar that decreases when taking damage. The last player standing wins.
- **Survivability:** You have a hunger and thirst meter, make sure they don't go to 0 or you'll start to die!

## Cloning and Building

To clone and build **Farm Fighter**, follow these instructions:

1. **Clone the Repository:**

```bash
git clone https://proudcircle.xyz/illyum/FarmFighter.git
cd FarmFighter
```
Create a Build Directory:

It's recommended to build in a separate directory from the source.

```bash
mkdir build
cd build
```

Generate Build Files with CMake:

Run the following command to generate the build files:

```bash
cmake ..
```

Build the Project:

After generating the build files, compile the project:

```bash
cmake --build .
```

Run the Game:

Once the build process completes, you can run the game executable found in the build directory.

```bash
./client/client
```

## Contributing

As this is a solo project made for fun, contributions are currently not being accepted. However, feel free to fork the project and experiment on your own!

## License

This project is licensed under the ??? License - see the LICENSE file for details.
